;===========================================================================================
; generalproc.asm   AsmGges France  http://www.chez.com/asmgges/
;===========================================================================================

;===========================================================================================
; Mettre  zro une zone mmoire
;-------------------------------------------------------------------------------------------
; @AdrZone = adresse zone mmoire  mettre  zro
; @Len     = longueur de la zone en octets
;===========================================================================================
ZeroMemory frame @AdrZone, @Len
    uses ecx,edi

    mov edi,[@AdrZone]
    mov ecx,[@Len]
    mov eax,0
    rep stosb

    ret
endf
;===========================================================================================
; Limiter le nombre de frames par seconde
;-------------------------------------------------------------------------------------------
; @FpsMax = Nombre de frames par secondes maximum
;-------------------------------------------------------------------------------------------
; Utilisation:
; invoke timeBeginPeriod,1    ;au dbut du programme
; mov D[FpsMax],60
;
; invoke GetTickCount         ;dans MessageLoop
; mov [TickCount],eax
; invoke FpsLimiter,[FpsMax]
;
; invoke timeEndPeriod,1      ; la fin du programme
;===========================================================================================
FpsLimiter frame @FpsMaxi
    uses ebx,edx
    local .DelayTicks:D
    local .MinTicksForSleep:D

    cmp D[@FpsMaxi],0
    jne >
        ret
    :
    invoke QueryPerformanceFrequency,addr PerfFreq

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    div D[@FpsMaxi]
    mov [.DelayTicks],eax

    mov eax,D[PerfFreq]
    mov edx,D[PerfFreq+4]
    mov ebx,500
    div ebx
    mov [.MinTicksForSleep],eax

    .loop1:
        .loop2:
            invoke QueryPerformanceCounter,addr PerfCounter
            mov eax,D[PerfCounter]
            mov edx,D[PerfCounter+4]

            cmp edx,[NextTimeEdx] 
            jne >.exit
            cmp eax,[NextTimeEax]
            jae >.exit
            
            mov ebx,[NextTimeEax]
            sub ebx,eax
        cmp ebx,[.MinTicksForSleep]
        jb .loop2
        push eax
        invoke Sleep,1
        pop eax
    jmp .loop1

 .exit:
    add eax,[.DelayTicks]
    mov [NextTimeEax],eax
    mov [NextTimeEdx],edx

    ret
endf
;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================
